
% this script calculate the accuracy of GHRFSOM
% will use the CorSet, Links, XLable, Heir and Layer

function HAcc = Eva_HAcc(X,Pm,Child,CorSet,Links,XLable,LinkType)

for i=1:length(CorSet) % convert CorSet from logic type to double type
    CorSet{i}=double(CorSet{i});
end
ClassLth=length(unique(XLable));
Judger=zeros(ClassLth,1); % Judger stores the best matching rate for selecting the best matching result
InterSectLth=zeros(ClassLth,1); %InterSectLth stores the best matching result
for i=1:ClassLth
    TrueGroup=find(XLable==i);
    for j=1:Pm.TotalNumNode
        NumSubNodes=length(Child{j});
        if NumSubNodes>=1
            for h=1:NumSubNodes % if node "j"'s child node "h" is a leaf node, do the following processing
                if Child{j}(h)==0 
                    LeafList=find(CorSet{j}(h,:)==1);
                    LeafLth=length(LeafList);
                    if LeafLth>=2
                        LeafSet=X(LeafList,:);
                        if LinkType==1
                            SubLink=linkage(LeafSet,'single');
                        end
                        if LinkType==2
                            SubLink=linkage(LeafSet,'average');
                        end
                        if LinkType==3
                            SubLink=linkage(LeafSet,'complete');
                        end
                        if LinkType==4
                            SubLink=linkage(LeafSet,'single');
                        end                        
                        LinkSet=zeros(LeafLth,Pm.Xlth);
                        for m=1:LeafLth-1
                            if SubLink(m,1)<=LeafLth && SubLink(m,2)<=LeafLth
                                LinkSet(m,LeafList([SubLink(m,1),SubLink(m,2)]))=1;
                            else
                                MidSet1=zeros(1,Pm.Xlth);
                                MidSet2=zeros(1,Pm.Xlth);
                                if SubLink(m,1)>LeafLth
                                    MidSet1=LinkSet(SubLink(m,1)-LeafLth,:);
                                else
                                    MidSet1(LeafList(SubLink(m,1)))=1;
                                end
                                if SubLink(m,2)>LeafLth
                                    MidSet2=LinkSet(SubLink(m,2)-LeafLth,:);
                                else
                                    MidSet2(LeafList(SubLink(m,2)))=1;
                                end
                                LinkSet(m,:)=MidSet1+MidSet2;
                            end
                        end
                        for m=1:LeafLth-1
                            Group=find(LinkSet(m,:)==1);
                            ChallengValue=length(intersect(Group,TrueGroup))/length(union(Group,TrueGroup));
                            if Judger(i)<ChallengValue
                                Judger(i)=ChallengValue;
                                InterSectLth(i)=length(intersect(Group,TrueGroup));
                            end
                        end
                    end    
                end
            end
            if isempty(Links{j})==0 % for all the child nodes of node "j", do the following processing
                LinkSet=zeros(NumSubNodes,Pm.Xlth);
                for m=1:NumSubNodes-1
                    if Links{j}(m,1)<=NumSubNodes && Links{j}(m,2)<=NumSubNodes
                        LinkSet(m,:)=CorSet{j}(Links{j}(m,1),:)+CorSet{j}(Links{j}(m,2),:);
                    else
                        MidSet1=zeros(1,Pm.Xlth);
                        MidSet2=zeros(1,Pm.Xlth);
                        if Links{j}(m,1)>NumSubNodes
                            MidSet1=LinkSet(Links{j}(m,1)-NumSubNodes,:);
                        else
                            MidSet1=CorSet{j}(Links{j}(m,1),:);
                        end
                        if Links{j}(m,2)>NumSubNodes
                            MidSet2=LinkSet(Links{j}(m,2)-NumSubNodes,:);
                        else
                            MidSet2=CorSet{j}(Links{j}(m,2),:);
                        end
                        LinkSet(m,:)=MidSet1+MidSet2;
                    end
                end
                for m=1:NumSubNodes-1
                    Group=find(LinkSet(m,:)==1);
                    ChallengValue=length(intersect(Group,TrueGroup))/length(union(Group,TrueGroup));
                    if Judger(i)<ChallengValue
                        Judger(i)=ChallengValue;
                        InterSectLth(i)=length(intersect(Group,TrueGroup));
                    end
                end
            end
        end
    end
end
HAcc=sum(InterSectLth)/Pm.Xlth;

end
