
% This script excute hierarchical clustering using the incremental version of our approach. 
%Corresponding hierarchical accuracy is calculated.

clear;
clc;

load seed;
X=seed;
[Pm.Xlth,Pm.Xwd]=size(X);
Pm.NumClass=length(unique(X(:,Pm.Xwd)));
Pm.Xwd=Pm.Xwd-1;

Fold=10;
HAcc=zeros(Fold,1);

rand('seed',11);
for f=1:Fold
    RandList=randperm(Pm.Xlth,Pm.Xlth);
    XR=X(RandList,:);
    [HAcc(f)] = IGMTTMain(XR,1,0.1,Pm);
    % first input: data set 
    % second input: 1 stands for max-min normalization, 2 stands for mean-standard normalization 
    % third input: 0.1 means we use the former 10% inputs to train the coarse topology
    fold=f % display the present fold
end 
AccMean=mean(HAcc)
